package com.perforce.hive;

import static org.junit.Assert.fail;

import java.io.IOException;
import java.net.HttpURLConnection;
import java.net.URL;

import spark.utils.IOUtils;

public class UnitSpark {

	public static UnitResponse request(String method, String path) {
		try {
			URL url = new URL("http://localhost:4567" + path);
			HttpURLConnection connection = (HttpURLConnection) url.openConnection();
			connection.setRequestMethod(method);
			connection.setDoOutput(true);

			int count = 10;
			while (count > 0) {
				try {
					connection.connect();
					break;
				} catch (IOException e) {
					try {
						Thread.sleep(20);
					} catch (InterruptedException ex) {
						Thread.currentThread().interrupt();
					}
				}
				count--;
			}

			String body = IOUtils.toString(connection.getInputStream());
			UnitResponse response = new UnitResponse(connection.getResponseCode(), body);
			connection.disconnect();

			return response;
		} catch (IOException e) {
			e.printStackTrace();
			fail("Sending request failed: " + e.getMessage());
			return null;
		}
	}
}
